/***************************************************************
 * Part     : FIFO Cu
 * Author   : 2019/01/14	nauzou
 */

#include "fifo.h"

/********************************************************************
		ʊ֐
********************************************************************/
/*---------------------------------------------------------
 * Function :
 *  @w FIFO obt@B
 *
 * Arguments :
 *		hdl			:  FIFO obt@̃nh
 *		buf			: FIFO obt@̃|C^
 *		buf_size	: FIFO obt@̃TCYi1 ` 255j
 */
void
fifo_init( FIFOBUF *hdl,uint8 *buf,uint8 buf_size )
{
	INTFLG	iflag;
	
	/* FIFO obt@̑쒆͊荞݂֎~	*/
	iflag = irq_disable();
	
	hdl->buf_      = buf;
	hdl->buf_size_ = buf_size;
	hdl->add_idx_  = 0;
	hdl->out_idx_  = 0;
	hdl->data_num_ = 0;
	
#if FIFO_BUF_INITIALIZE
	/* obt@ 0 	*/
	memset( hdl->buf_,0,hdl->buf_size_ );
#endif
	
	/* 荞݃tO𕜋A	*/
	irq_enable( iflag );
}
/*---------------------------------------------------------
 * Function :
 *  @w FIFO obt@֎w̃f[^ǉB
 *
 * Arguments :
 *		hdl			: f[^ǉ FIFO obt@̃nh
 *		data		: ǉf[^
 *
 * Return :
 *  @IȂ true ԂB
 *  @f[^ۑłȂ false ԂB
 */
bool
fifo_add( FIFOBUF *hdl,uint8 data )
{
	INTFLG	iflag;
	bool	ret;
	
	/* FIFO obt@̑쒆͊荞݂֎~	*/
	iflag = irq_disable();
	
	if( hdl->data_num_ >= hdl->buf_size_ )
		ret = false;
	else {
		hdl->buf_[hdl->add_idx_] = data;
		hdl->add_idx_++;
		if( hdl->add_idx_ >= hdl->buf_size_ )
			hdl->add_idx_ = 0;
		hdl->data_num_++;
		
		ret = true;
	}
	
	/* 荞݃tO𕜋A	*/
	irq_enable( iflag );
	
	return ret;
}
/*---------------------------------------------------------
 * Function :
 *  @w FIFO obt@f[^oB
 *
 * Arguments :
 *		hdl			: f[^o FIFO obt@̃nh
 *		buf			: of[^ۑobt@
 *
 * Return :
 *  @IȂ true ԂB
 *  @of[^Ȃ false ԂB
 */
bool
fifo_get( FIFOBUF *hdl,uint8 *buf )
{
	INTFLG	iflag;
	bool	ret;
	
	/* FIFO obt@̑쒆͊荞݂֎~	*/
	iflag = irq_disable();
	
	if( hdl->data_num_ == 0 )
		ret = false;
	else {
		*buf = hdl->buf_[hdl->out_idx_];
		hdl->out_idx_++;
		if( hdl->out_idx_ >= hdl->buf_size_ )
			hdl->out_idx_ = 0;
		hdl->data_num_--;
		
		ret = true;
	}
	
	/* 荞݃tO𕜋A	*/
	irq_enable( iflag );
	
	return ret;
}
