/***************************************************************
 * Part     : USART ʐMhCo[E`t@C
 * Author   : 2019/01/14	nauzou
 */

#pragma	once

#include <stdarg.h>
#include "std.h"
#include "fifo.h"

/********************************************************************
		eݒ
********************************************************************/
/*---------------------------------------------------------
  @ʐMx
---------------------------------------------------------*/
#define	BAUD_RATE						(38400)
/*---------------------------------------------------------
  @usart_vprintf(),usart_printf() ŏ\
  WJ̕
---------------------------------------------------------*/
#define	USART_MAX_STR					(80)
/*---------------------------------------------------------
  @usart_gets() ̋ؕ
---------------------------------------------------------*/
#define	DELIMITER_CHAR					'\n'
/*---------------------------------------------------------
  @Mobt@TCYi1 ` 255j
---------------------------------------------------------*/
#define	USART_MAX_SEND_BUF				(24)
#define	USART_MAX_RECV_BUF				(8)
/*---------------------------------------------------------
  @e֐̗L^ݒ
---------------------------------------------------------*/
#define	ENABLE_USART_PUTS				(1)			/* 1  usart_puts() L						*/
#define	ENABLE_USART_GETS				(1)			/* 1  usart_gets() L						*/
#define	ENABLE_USART_GETS_BACK_SPACE	(1)			/* 1  usart_gets() ł̃obNXy[XL		*/
#define	ENABLE_USART_PRINTF				(1)			/* 1  usart_vprintf(),usart_printf() L		*/

/********************************************************************
		vg^Cv錾
********************************************************************/
/* usart.c	*/
extern	void		init_usart( void );
extern	uint8		usart_recv_rest( void );
extern	uint8		usart_send_rest( void );
extern	void		usart_putc( char data );
extern	char		usart_getc( void );
#if ENABLE_USART_PUTS || ENABLE_USART_PRINTF
extern	void		usart_puts( const char *str );
extern	void		usart_puts_p( const char *str );
#endif
#if ENABLE_GETS
extern	void		usart_gets( char *buf );
#endif
#if ENABLE_USART_PRINTF
extern	void		usart_vprintf( const char *form,va_list arg );
extern	void		usart_vprintf_p( const char *form,va_list arg );
extern	void		usart_printf( const char *form,... );
extern	void		usart_printf_p( const char *form,... );
#endif

/********************************************************************
		USART I/O Tv
********************************************************************/
/*
UDR0	USART Mf[^WX^ 0

UCSR0A	USART Rg[Xe[^XWX^ 0A
	7:RXC0		R [0]	MtO
	6:TXC0		RW[0]	MtO
	5:UDRE0		R [1]	Mf[^WX^󂫃tO
	4:FE0		R [0]	t[~OG[tO				
	3:DOR0		R [0]	f[^I[o[G[tO			
	2:UPE0		R [0]	peB[G[tO					
	1:U2X0		RW[0]	{tO								
	0:MPCM0		RW[0]	}`vZbT[ʐM[htO		

UCSR0B	USART Rg[Xe[^XWX^ 0B
	7:RXCIE0	RW[0]	M荞݋tO
	6:TXCIE0	RW[0]	M荞݋tO
	5:UDRIE0	RW[0]	Mf[^WX^󂫊荞݋tO
	4:RXEN0		RW[0]	MtO
	3:TXEN0		RW[0]	MtO
	2:UCSZ02	RW[0]	1										
	1:RXB80		R [0]	Mf[^rbgWif[^ 9 bit [h 9 bit ځj UDR0 ǂޑOɓǂݏo	
	0:TXB80		RW[0]	Mf[^rbgWif[^ 9 bit [h 9 bit ځj UDR0 ɏOɏނ	

UCSR0C	USART Rg[Xe[^XWX^ 0C
	7:UMSEL01	RW[0]	2
	6:UMSEL00	RW[0]	2
	5:UPM01		RW[0]	3										
	4:UPM00		RW[0]	3										
	3:USBS0		RW[0]	MXgbvrbgi0  1 bitA1  2 bitjM̓XgbvrbgPŌŒ	
	2:UCSZ01	RW[1]	1		5
	1:UCSZ00	RW[1]	1		5
	0:UCPOL0	RW[0]	4		5

UBRR0L			RW[0]	USART {[[g 0 WX^ (Low)
UBRR0H			RW[0]	USART {[[g 0 WX^ (High)	 Bit 4 ` 7 ͖

1
	UCSZ0	f[^

	UCSZ02	UCSZ01	UCSZ00
	     0	     0	     0		5 bit
	     0	     0	     1		6 bit
	     0	     1	     0		7 bit
	     0	     1	     1		8 bit
	     1	     0	     0		Reserved
	     1	     0	     1		Reserved
	     1	     1	     0		Reserved
	     1	     1	     1		9 bit

2
	UMSEL0	USART [h

	UMSEL01	UMSEL00
	      0	      0		񓯊[h
	      0	      1		[h
	      1	      0		Reserved
	      1	      1		SPI Master

3
	UPM0	peB[h

	UPM01	UPM00
	    0	    0		peB[Ȃ
	    0	    1		Reserved
	    1	    0		
	    1	    1		

4
	UCPOL0	NbNɐ

	UCPOL0		            TxD0 XV	             RxD0XV
	     0		XCK0 オGbW	XCK0 GbW
	     1		XCK0 GbW	XCK0 オGbW

5
	SPI Master [h UDPRD0(UCSZ01),UCPHA0(UCSZ00),UCPOL0

	UDPRD0	0  MSB 瑗MA1  LSB 瑗M

	UCPOL0	UCPHA0	SPI Mode	 XCK ɐ	オGbW	GbW
	    0	    0	       0	Low -> Hi	          Sample	           Setup
	    0	    1	       1	Low -> Hi	           Setup	          Sample
	    1	    0	       2	Hi -> Low	           Setup	          Sample
	    1	    1	       3	Hi -> Low	          Sample	           Setup


	SPI Master [h Reserved
*/
